﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using WpfApplication1.Models;
using XnaMapGenerator3D.Models;
using XnaMapGenerator3D.Services.GeneratorServices;

namespace XnaMapGenerator3D.Services
{
    public class MapGenService
    {
        private BGame _game;
        public Dictionary<int,Center> Centers { get; set; }
        public Dictionary<int, List<Corner>> Corners { get; set; }
        public Dictionary<int, List<Edge>> Edges { get; set; }
        private IMapService _mapService;
        private int MapX;
        private int MapY;
        private int MapZ;
        private Vector3 _center;
        private int _privateRandomSeed;

        public MapGenService(BGame game, int mapX, int mapY, int mapZ, int zoneCount, IslandSize idata, int seed)
        {
            _game = game;
            Centers = new Dictionary<int, Center>();
            Corners = new Dictionary<int, List<Corner>>();
            Edges = new Dictionary<int, List<Edge>>();

            _center = idata.Center;

            MapX = mapX;
            MapY = mapY;
            MapZ = mapZ;

            _mapService = new MapService(game, this, idata.Height, mapY, idata.Width);

            var points = new HashSet<BenTools.Mathematics.Vector>();
            
            var rnd = new Random(seed);

            points.Clear();
            for (int i = 0; i < zoneCount; i++)
            {
                points.Add(new BenTools.Mathematics.Vector(Math.Abs(rnd.NextDouble() * idata.Height),
                                                            Math.Abs(rnd.NextDouble() * idata.Width)));
            }

            _mapService.LoadMap(new LoadMapParams(points, true, idata, _privateRandomSeed));
        }

        public void Draw()
        {
            
        }
    }
}
